#include "mpi.h"
#include <unistd.h>
#include <stdlib.h>
#include "assert.h"
#include <stdio.h>

int main(int argc, char* argv[]) {
  MPI_Init(&argc, &argv);

  int rank, size;
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  if (rank == 0) {
    int msglen = rand() % 1024;
    int *msg = new int[msglen];
    for (int i = 0; i < msglen; i++) {
      msg[i] = rand();
    }

    MPI_Send(msg, msglen, MPI_INTEGER, 1, 0, MPI_COMM_WORLD);
    delete [] msg;

  } else if (rank == 1) {
    MPI_Status status;
    MPI_Probe(MPI_ANY_SOURCE, 0, MPI_COMM_WORLD, &status);
    int msglen;
    MPI_Get_count(&status, MPI_INTEGER, &msglen);
    int* msg = new int[msglen];
    MPI_Recv(msg, msglen, MPI_INTEGER, MPI_ANY_SOURCE, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
    delete [] msg;
    printf("Successfully received %d integers.\n", msglen);
  }

  printf("Process %d done.\n", rank);

  MPI_Finalize();
  return 0;
}
